function love.load()
  love.physics.setMeter(64) 
  world = love.physics.newWorld(0, 0, true)
  math.randomseed(os.time())
  maxspeed = 75
  moving = false
  bullets = {}
  enemies = {}
  estemp = 0
  estemp2 = 0
  blastshots = 12
  world:setCallbacks(beginContact, endContact, preSolve, postSolve)
  
      map = {
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
{1,0,1,1,0,0,0,1,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,1,0,0,0,0,0,0,1},
{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,1,1,0,0,0,0,1},
{1,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,1,0,0,1,0,0,0,1,0,1,0,0,0,1,0,1},
{1,0,1,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,1,0,0,1},
{1,0,1,1,0,0,1,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1},
{1,1,1,1,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1},
{1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1},
{1,1,0,0,0,0,0,1,0,0,1,0,1,1,1,0,0,0,0,0,1,0,0,0,0,1,0,1,0,0,0,1},
{1,0,0,0,1,0,0,1,0,0,0,0,0,1,0,0,0,1,1,0,1,1,1,0,1,1,0,0,1,1,0,1},
{1,0,0,0,1,0,1,1,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1},
{1,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,1,0,0,0,1,0,0,0,1,1,1,1},
{1,1,0,0,0,1,0,1,0,0,1,0,1,1,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1},
{1,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,1,1,1,1,1,0,0,1,0,1},
{1,0,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,1,0,0,1,1,0,0,1},
{1,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1},
{1,1,0,1,0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}

	}
	mapscale = 30 --Must be 30 for 960x540 res
  	windowx = 960
	windowy = 540
	centerx = windowx/2
	centery = windowy/2
	settings={vsync=true,resizable=false,centered=true,fsaa=8}
	love.window.setMode(windowx, windowy, settings)
	love.window.setTitle("PartyCöw - WIP")
    
	shotimg = love.graphics.newImage("resources/shotimg.png")
	dark = love.graphics.newImage("resources/light.png")
  
	paused = false
  
  
  
  objects = {} -- table for all objects
 
  objects.ball = {}
  objects.ball.body = love.physics.newBody(world, windowx/2, windowy/2, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
  objects.ball.shape = love.physics.newCircleShape(10) --the ball's shape has a radius of 20
  objects.ball.fixture = love.physics.newFixture(objects.ball.body, objects.ball.shape, 1) -- Attach fixture to body and give it a density of 1.
  objects.ball.fixture:setRestitution(0) --let the ball bounce
  objects.ball.image = love.graphics.newImage("resources/player.png")
  
  ---WORLDGEN *YAY*------------------------------------------------------
  -----------------------------------------------------------------------
  -----------------------------------------------------------------------
  theworld = {}
  for wy = 1,#map,1 do 
  for wx = 1,#map[wy],1 do
  if map[wy][wx] == 1 then
  objects.blockw = {}
  objects.blockw.body = love.physics.newBody(world, (-mapscale/2)+wx*mapscale, (-mapscale/2)+wy*mapscale, "static")
  objects.blockw.shape = love.physics.newRectangleShape(0, 0, mapscale, mapscale)
  objects.blockw.fixture = love.physics.newFixture(objects.blockw.body, objects.blockw.shape, 2)
  table.insert(theworld,objects.blockw)
  end
  end
  end
  
  love.graphics.setBackgroundColor(104, 136, 100) 
end

function createBullet(ballx2,bally2,angle2)
  local bullet = {}
    
  bullet.shape = love.physics.newCircleShape(1.5)
       
  bullet.body = love.physics.newBody(world, ballx2+(math.cos(angle2)*14), bally2+(math.sin(angle2)*14), "dynamic")
  local shotx, shoty = bullet.body:getPosition()
  bullet.body:applyLinearImpulse((shotx-ballx2)*15,(shoty-bally2)*15)
       
  bullet.fixture = love.physics.newFixture(bullet.body, bullet.shape, 1)
  bullet.fixture:setRestitution(0)
   table.insert(bullets, bullet)
end

function createEnemy(posx,posy)
  local enemy = {}
    
  enemy.shape = love.physics.newCircleShape(6)
  if posx and posy then
  enemy.body = love.physics.newBody(world, posx,posy, "dynamic")
  else
  enemy.body = love.physics.newBody(world, windowx/2+20,windowy/2, "dynamic")
  end
  enemy.body:applyLinearImpulse(0,0)
       
  enemy.fixture = love.physics.newFixture(enemy.body, enemy.shape, 1)
  enemy.fixture:setRestitution(0.25)
   table.insert(enemies, enemy)
end
 
function love.update(dt)
if not paused then
estemp = estemp + dt
if estemp >= 1 and #enemies < 20 then
estemp = 0
createEnemy(math.random(50,750),math.random(50,750))
end

estemp2 = estemp2 + dt
if estemp2 > 1.5 then
estemp2 = 0
for i = 1,#enemies do
local enemy = enemies[i] 
  local thisx, thisy = enemy.body:getPosition()
  local tarx, tary = objects.ball.body:getPosition()
  local angle = math.atan2(tary - thisy, tarx - thisx)

  tarxc = thisx+math.cos(angle)*8
  taryc = thisy+math.sin(angle)*8
  enemy.body:setLinearVelocity((tarxc-thisx)*15,(taryc-thisy)*15)
end

end

  world:update(dt)
  x,y=objects.ball.body:getLinearVelocity()
  --------------------------------------------
    if x>maxspeed then
  objects.ball.body:setLinearVelocity(maxspeed,y)
  end
    if x<-maxspeed then
  objects.ball.body:setLinearVelocity(-maxspeed,y)
  end
    if y>maxspeed then
  objects.ball.body:setLinearVelocity(x,maxspeed)
  end
    if y<-maxspeed then
  objects.ball.body:setLinearVelocity(x,-maxspeed)
  end
  ---------------------------------------------
  x,y=objects.ball.body:getLinearVelocity()
  if x<20 and x>-20 then
  objects.ball.body:setLinearVelocity(0,y)
  end
  if y<20 and y>-20 then
  objects.ball.body:setLinearVelocity(x,0)
  end
  
  
  x,y=objects.ball.body:getLinearVelocity()
  if love.keyboard.isDown("d") and x<maxspeed then
    objects.ball.body:applyForce(100, 0)
  end
  if love.keyboard.isDown("a") and x>-maxspeed  then 
    objects.ball.body:applyForce(-100, 0)
  end
  if love.keyboard.isDown(" ") then 
    objects.ball.body:setPosition(windowy/2, windowy/2)
  end
  if love.keyboard.isDown("w") and y>-maxspeed then
    objects.ball.body:applyForce(0, -100)
  end
  if love.keyboard.isDown("s") and y<maxspeed  then
    objects.ball.body:applyForce(0, 100)
  end
end
end

function love.mousepressed(x,y,button)
if button == "l" and not paused then
  local ballx, bally = objects.ball.body:getPosition()
  local mx, my = love.mouse.getPosition()
  local angle = math.atan2(my - bally, mx - ballx)
  createBullet(ballx,bally,angle)
end
end

function love.keypressed(key)
if key == "p" then
paused = not paused
end
if key == "f" and not paused then
local ballx3, bally3 = objects.ball.body:getPosition()
	for shotc = -math.pi,math.pi-math.pi/(blastshots/2),math.pi/(blastshots/2) do
	  createBullet(ballx3,bally3,shotc)
	end
  end
end

function beginContact(a, b, coll)
  for ih = #bullets, 1, -1 do
    local bullet = bullets[ih]
    if not bullet then break end
    if a == bullet.fixture then
	for i2 = #enemies,1,-1 do
	local enemy = enemies[i2]
    if not enemy then break end
	if b == enemy.fixture then
	  enemy.fixture:getBody():destroy()
	  table.remove(enemies,i2)
	  break
	end
	end
    a:getBody():destroy()
    table.remove(bullets, ih)
    break
	end
    if b == bullet.fixture then
	 for i2 = #enemies,1,-1 do
	  local enemy = enemies[i2]
      if not enemy then break end
	  if a == enemy.fixture then
      enemy.fixture:getBody():destroy()
	  table.remove(enemies,i2)
	  break
	  end
	  end
	b:getBody():destroy()
      table.remove(bullets, ih)	  
      break
     end
  end
end

function love.draw()
  love.graphics.setColor(255, 255, 255)
  local mx, my = love.mouse.getPosition()
  local bx, by = objects.ball.body:getPosition()
  objects.ball.body:setAngle(math.atan2(my - by, mx - bx))
  love.graphics.circle("fill", objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.shape:getRadius())
  love.graphics.draw(objects.ball.image, objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.body:getAngle(),  1, 1, objects.ball.image:getWidth()/2, objects.ball.image:getHeight()/2)
  
  love.graphics.setColor(50, 0, 50)
  for i,v in pairs(bullets) do
  love.graphics.circle("fill",v.body:getX(), v.body:getY(), v.shape:getRadius())
  end
  love.graphics.setColor(255, 255, 255)
   for i,v in pairs(enemies) do
    love.graphics.circle("fill",v.body:getX(), v.body:getY(), v.shape:getRadius())
    local px, py = objects.ball.body:getPosition()
    local bx, by = v.body:getPosition()
    v.body:setAngle(math.atan2(py - by, px - bx))
	  love.graphics.draw(shotimg, v.body:getX(), v.body:getY(), v.body:getAngle(),  1, 1, shotimg:getWidth()/2, shotimg:getHeight()/2)
  
   end
  love.graphics.setColor(50, 50, 50)
  for i,v in pairs(theworld) do  --Draw my world <3
  love.graphics.polygon("fill", v.body:getWorldPoints(v.shape:getPoints()))
  end
  love.graphics.draw(dark,objects.ball.body:getX()-dark:getWidth()/2, objects.ball.body:getY()-dark:getHeight()/2)
  
  if paused then
  love.graphics.setColor(255, 0, 0)
  love.graphics.print("Paused",centerx-25,centery)
  end
end
